//
// Copyright (C) 1999-2004 WideStudio Development Team
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// WIDESTUDIO DEVELOPMENT TEAM BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
// Except as contained in this notice, the name of WideStudio Development Team
// shall not be used in advertising or otherwise to promote the sale, use or
// other dealings in this Software without prior written authorization from
// WideStudio Development Team.

#ifndef WSDRES_H
#define WSDRES_H

#include <WScom.h>
#include <WSCroot.h>
#include <WSCstring.h>

class WSDres :public WSCroot{

 protected:
  char* _src_name;
  long  _value1;
  long  _value2;
  long  _value3;
  short _id;
  unsigned _initialized:1;

  WSDLEX32 long setValue1(long);
  WSDLEX32 long setValue2(long);
  WSDLEX32 long setValue3(long);
  WSDLEX32 void setInitialized(WSCbool fl);

  WSDLEX32 virtual long initialize();
  WSDLEX32 virtual long destroy();

 public:
  WSDLEX32 WSDres();
  WSDLEX32 virtual ~WSDres();

  WSDLEX32 long setSrc(char*);
  WSDLEX32 long setId(short);
  WSDLEX32 WSCbool isInitialized();

  WSDLEX32 long getValue1();
  WSDLEX32 long getValue2();
  WSDLEX32 long getValue3();
  WSDLEX32 short getId();
  WSDLEX32 char* getSrc();

  WSMFclassDef(WSDres,WSCroot);
};
#endif
